<?xml version="1.0" encoding="utf-8"?>
<databaseChangeLog
    xmlns="http://www.liquibase.org/xml/ns/dbchangelog"
    xmlns:ext="http://www.liquibase.org/xml/ns/dbchangelog-ext"
    xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance"
    xsi:schemaLocation="http://www.liquibase.org/xml/ns/dbchangelog http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-3.5.xsd
                        http://www.liquibase.org/xml/ns/dbchangelog-ext http://www.liquibase.org/xml/ns/dbchangelog/dbchangelog-ext.xsd">

    <property name="now" value="now()" dbms="h2"/>

    <property name="now" value="now()" dbms="mysql"/>
    <property name="autoIncrement" value="true"/>
    <property name="now" value="GETDATE()" dbms="mssql"/>

    <property name="floatType" value="float4" dbms="postgresql, h2"/>
    <property name="floatType" value="float" dbms="mysql, oracle, mssql"/>
    
    <property name="UUID" value="binary(16)" dbms="mysql, mariadb"/>
    <property name="UUID" value="UUID" dbms="postgresql, h2, oracle, mssql"/>

    <property name="timestamp" value="datetime" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>

    <property name="Integer" value="int" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>
    <property name="String" value="varchar(100)" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>

    <property name="BigDecimal" value="decimal(18,4)" dbms="mysql, mariadb, postgresql, h2, oracle, mssql"/>
    <!--
        Added the entity Orders.
    -->
    <changeSet id="20170101000000-1" author="jhipster">
        <createTable tableName="orders">
            <column name="idorder" type="${UUID}">
                <constraints primaryKey="true" nullable="false"/>
            </column>
            
            <column name="ordernumber" type="varchar(255)">
                <constraints nullable="true" />
            </column>

            <column name="dtentry" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="dtorder" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="idordtyp" type="${Integer}">
                <constraints nullable="true" />
            </column>

            <!-- jhipster-needle-liquibase-add-column - JHipster will add columns here, do not remove-->
        </createTable>

        <dropDefaultValue tableName="orders" columnName="dtentry" columnDataType="datetime"/>
        <dropDefaultValue tableName="orders" columnName="dtorder" columnDataType="datetime"/>
        
        <createTable tableName="orders_payment">
            <column name="payments_id" type="${UUID}">
                <constraints nullable="false"/>
            </column>
            <column name="orders_id" type="${UUID}">
                <constraints nullable="false"/>
            </column>
        </createTable>

        <addPrimaryKey columnNames="orders_id, payments_id" tableName="orders_payment"/>

        
        <createTable tableName="orders_status">
            
            <column name="idstatus" type="${UUID}"> 
                <constraints primaryKey="true" nullable="false"/>
            </column>

            <column name="idorder" type="${UUID}">
                <constraints nullable="true" />
            </column>

            <column name="idstatustype" type="${Integer}">
                <constraints nullable="true" />
            </column>

            <column name="dtthru" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="dtfrom" type="${timestamp}">
                <constraints nullable="true" />
            </column>

        </createTable>

        <addForeignKeyConstraint baseColumnNames="idorder"
                                 baseTableName="orders_status"
                                 constraintName="fk_orders_from_status"
                                 referencedColumnNames="idorder"
                                 referencedTableName="orders"/>        
        <createTable tableName="orders_role">
            
            <column name="idrole" type="${UUID}"> 
                <constraints primaryKey="true" nullable="false"/>
            </column>

            <column name="idorder" type="${UUID}">
                <constraints nullable="true" />
            </column>

            <column name="idroletype" type="${Integer}">
                <constraints nullable="true" />
            </column>

            <column name="idparty" type="${UUID}">
                <constraints nullable="true" />
            </column>            

            <column name="dtthru" type="${timestamp}">
                <constraints nullable="true" />
            </column>

            <column name="dtfrom" type="${timestamp}">
                <constraints nullable="true" />
            </column>

        </createTable>

        <addForeignKeyConstraint baseColumnNames="idorder"
                                 baseTableName="orders_role"
                                 constraintName="fk_orders_from_role"
                                 referencedColumnNames="idorder"
                                 referencedTableName="orders"/>
    </changeSet>
    <!-- jhipster-needle-liquibase-add-changeset - JHipster will add changesets here, do not remove-->
</databaseChangeLog>
